<?php
/**
 *
 * @package	    Pay My Bill Module
 * @subpackage	Pay My Bill Module
 * @version     1.0.0
 * @description Pay My Bill Module
 * @copyright	  Copyright © 2013 - All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */
//ini_set("display_errors",0);
//error_reporting(E_ALL);

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class PMBegopay
{
  function checkMethod($params)
  {
    $vendor_missing=JText::_( 'PMB_EGOPAY_MODULE_ERR_VENDOR' );
    $password_missing=JText::_( 'PMB_EGOPAY_MODULE_ERR_PASSWORD' );
    $vendor_name=trim($params->get('egopay_user'));
    $vendor_password=trim($params->get('egopay_password'));
    
    if($vendor_name=='')
    {
      ?>
        <div class="pmb_error"><?php echo $vendor_missing;?></div>
      <?php
      return false;
    }
    else if($vendor_password=='')
    {
      ?>
        <div class="pmb_error"><?php echo $password_missing;?></div>
      <?php
      return false;
    }

    return true;
  }
  function getPMBDomain()
  {
    $domain=str_ireplace("www.","",$_SERVER['HTTP_HOST']);
    $is_ip = ip2long($domain) !== false;
    if($is_ip)
    {
      return false;
    }
    else if(trim($domain)=='')
    {
      return false;
    }
    
    return $domain;
  }
  function doPayment($params,$details,$all_params)
  {
    /*
    $dchk=$all_params['dchk'];
    $lic=$all_params['pmblic'];
    $the_domain=$this->getPMBDomain();
    if($the_domain)
    {
      $chk=md5($lic.$the_domain);
      if($dchk!=$chk)
      {
        echo '<font color="red"><strong>'.JText::_( 'PMB_MODULE_LICENSE_ERR' ).'</strong></font>';
        exit;
      }
    }
    */
    $product_name=$params->get('product_name');
    $invoice_field=$params->get('show_inv_field');
    $cost_per_transaction=$params->get('egopay_trans_cost')+0;
    $percent_per_transaction=$params->get('egopay_trans_percent_cost')+0;
    
    $vendor_name=trim($params->get('egopay_user'));
    $vendor_password=trim($params->get('egopay_password'));
    
    $mode='LIVE';
    $currency=$params->get('egopay_currency');
    
    $details['subtotal']=$details['payment'];
    $payment=$details['payment'];
    if($cost_per_transaction>0)
    {
      $payment+=$cost_per_transaction;
    }
    if($percent_per_transaction>0)
    {
      $payment=$payment+($payment*$percent_per_transaction);
    }
    
    $payment=round($payment,2);
    $payment=number_format($payment,2);
    $details['payment']=$payment;
    $details['mode']=$mode;
    $details['currency']=$currency;
    if($params->get('mail_pending')!=0)
    {
      require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."functions".DS."functions.php");
      $pmbf=new PMBFunctions();
      $pmbf->sendConfirmationMail("pending",$all_params,$details,'EgoPay');//send pending mail
    }
    $pmbf->saveOrder($payment,$mode,$all_params,$details,'EgoPay');
        
    $oEgopay = new EgoPaySci(array(
      'store_id' => $vendor_name,
      'store_password' => $vendor_password
    ));
    
    $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' order.';
    
    if($invoice_field)
    {
      $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' for '.$details['InvNr'];
    }
    
    $hash_arr=array(
      'amount' => $payment,
      'currency' => $currency,
      'description' => $PaymentDescription,
      'cf_1' => $details['order_id'],
    );
    
    $hash_arr['success_url']=JROUTE::_(JURI::root()."modules/mod_paymybill/return/egopay_return.php");
    $hash_arr['fail_url']=JROUTE::_(JURI::root()."modules/mod_paymybill/return/egopay_failure.php?order_id=".$details['order_id']);
    $hash_arr['callback_url']=JROUTE::_(JURI::root()."modules/mod_paymybill/return/egopay_notify.php?order_id=".$details['order_id']);

    $hash = $oEgopay->createHash($hash_arr);
    $url = EgoPaySci::EGOPAY_PAYMENT_URL;
    $pmb_button='Redirecting to payment page';
    
    $html = '<html><head><title>Redirection</title></head><body><div style="margin: auto; text-align: center;">';
		$html.= "\n".'<form name="PMBfrm" id="PMBfrm" action="'.$url.'" method="post">';
    $html .= '<input type="hidden" name="hash" value="' . $hash . '" />';
		$html.= '<input type="submit"  value="'.$pmb_button.'" />';
		$html.= '</form></div>';
		$html.= ' <script type="text/javascript">';
		$html.= ' document.PMBfrm.submit();';
		$html.= ' </script></body></html>';
    
    ob_end_clean();
    
    echo $html;exit;
  }
}
/**
 * EgoPay Sci Class
 * @author EgoPay
 * @copyright 2013   
 */
class EgoPaySci
{
    /**
     * EgoPay SCI url
     */
    const EGOPAY_PAYMENT_URL = "https://www.egopay.com/payments/pay";
    
    /**
     * EgoPay Store ID
     */
    protected $_storeId;
    
    /**
     * EgoPay Store password
     */
    protected $_storePassword;
    
    /**
     * Set these urls if you don't want use the ones you have in the website
     * User gets redirected after success payment
     */
    protected $_successUrl;
    
    /**
     * User gets redirected then he goes back without paying
     */
    protected $_failUrl;
    
    /**
    * Constructor
    * @param mixed $aParams - parameters that initiate API object
    * The available parameters are:
    * Required:
    *   store_id - id of the store
    *   store_password - unique generated password for the store
    * Optional:
    *   success_url - success callback url
    *   fail_url - failed callback url
    */
    public function __construct($aParams)
    {
        //Required parameters
        $aRequired = array('store_id', 'store_password');
        $aOptional = array('success_url','fail_url');
                        
        foreach($aRequired as $required)
            if(!array_key_exists($required, $aParams) || !$aParams[$required])
                throw new EgoPayException("This param is required - '$required'");
        
        $aBoth = array_merge($aRequired,$aOptional);
        foreach($aBoth as $key)
            if(array_key_exists($key, $aParams) && $aParams[$key]) {
                $name = preg_replace('/(?<=_)([a-z]{1})/ie', 'strtoupper(\'$1\')', $key);
                $name = str_replace('_', '', $name);
                $name = '_' . $name;
                $this->{$name} = $aParams[$key];
            }
    }      
    
    /**
     * Creates confirmation url 
     * @param type $aData - data that will be sent
     * @return string - confirmation url
     */
    public function getConfirmationUrl($aData)
    {
        $sHash = $this->createHash($aData);                
        return self::EGOPAY_PAYMENT_URL . '/?hash=' . urlencode($sHash);      
    }   
    
    public function sendRequest($aData)
    {
    	$sUrl = $this->getConfirmationUrl($aData);
    	header('Location: '.$sUrl);
    }
    
    /**
     * Creates encoded data hash
     * @param type $aData
     * @return type 
     */
    public function createHash($aData)
    {
        $aRequired = array('amount','currency');
        
        foreach($aRequired as $required)
            if(!array_key_exists($required, $aData) || !$aData[$required])
                throw new EgoPayException("This param is required - '$required'");
            
        if (!empty($this->_successUrl))
            $aData['success_url'] = $this->_successUrl;
        if (!empty($this->_failUrl))
            $aData['fail_url'] = $this->_failUrl;
        
        $sData = serialize($aData);        
        $sResult = $this->_storeId . $this->encode($sData);
        return $sResult;
    }      
    
    /**
     * Required for encoding
     * @param type $string
     * @return type 
     */
    protected function safe_b64encode($string) {
        $data = base64_encode($string);
        $data = str_replace(array('+','/','='),array('-','_',''),$data);
        return $data;
    }

    /**
     * Encodes given value
     * @param type $value
     * @return type 
     */
    protected function encode($data){ 
        if(!$data){return false;}
        $iv_size = mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB);
        $iv = mcrypt_create_iv($iv_size, MCRYPT_RAND);
        $crypttext = mcrypt_encrypt(MCRYPT_RIJNDAEL_256, $this->_storePassword, $data, MCRYPT_MODE_ECB, $iv);
        return trim($this->safe_b64encode($crypttext)); 
    }
    
   
}

class EgoPaySciCallback 
{
    /**
     * Current SCI version
     */ 
    const VERSION = '1.1';
    
    /**
     * SCI payment URL
     */
    const EGOPAY_REQUEST_URL = "https://www.egopay.com/payments/request";
    
    /**
     * EgoPay Store ID
     */
    protected $_storeId;
    
    /**
     * EgoPay Store password
     */
    protected $_storePassword;
    
    /**
     * After specified amount of seconds, the request is treated as expired
     */
    protected $_timeOut = 15;
    
   /**
    * Constructor
    * @param mixed $aParams - parameters that initiate API object
    * The available parameters are:
    * Required:
    *   store_id - id of the store
    *   store_password - unique generated password for the store
    */
    public function __construct($aParams)
    {
        //Required parameters
        $aRequired = array('store_id','store_password');
        
        foreach($aRequired as $required)
            if(!array_key_exists($required, $aParams) || !$aParams[$required])
                throw new EgoPayException("This param is required - '$required'");
        
        foreach($aRequired as $key)
            if(array_key_exists($key, $aParams) && $aParams[$key]) {
                $name = preg_replace('/(?<=_)([a-z]{1})/ie', 'strtoupper(\'$1\')', $key);
                $name = str_replace('_', '', $name);
                $name = '_' . $name;
                $this->{$name} = $aParams[$key];
            }      
    }  
    
     /**
     * Sends response to the EgoPay server with data that was sent from EgoPay 
     * server
     * @param type $aParams
     * @return string response
     */    
    public function getResponse($aParams)
    {
        if (!function_exists('curl_init')) {
            die("Curl library not installed.");
            return false;
        }
        
        if(!isset($aParams['product_id']))
            throw new EgoPayException("This param is required - 'product_id'");
        
        $aPost = array('product_id' => $aParams['product_id'],
                       'store_id' => $this->_storeId,
                       'security_password' => $this->_storePassword,
                       'v' => self::VERSION);
 
    	$ch = curl_init();
    
    	curl_setopt($ch, CURLOPT_URL, self::EGOPAY_REQUEST_URL);
        curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10_5_6; en-us) AppleWebKit/525.27.1 (KHTML, like Gecko) Version/3.2.1 Safari/525.27.1");
    	curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_POST, true);
    	curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($aPost));
    	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    	curl_setopt($ch, CURLOPT_TIMEOUT, $this->_timeOut);
    	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    
    	$response = curl_exec($ch);
        
        if (!curl_errno($ch)) { #No errors
            $response_info = curl_getinfo($ch);
            if ($response_info['http_code'] != 200) {
                throw new EgoPayException('Invalid request to EgoPay. Response code: '. $response_info['http_code']);
            }        
        } else {
            if($response == 'INVALID')
                throw new EgoPayException('Invalid request to EgoPay');
        }

    	curl_close($ch);

        $aResponse = array();
        parse_str($response, $aResponse);

        return $aResponse;
    }
}

/**
 * EgoPay Api Exception class
 */
class EgoPayException extends Exception {
    
}
?>